{"openapi":"3.0.0","info":{"title":"3gpp-pdtq-policy-negotiation","version":"1.0.0-alpha.3","description":"API for PDTQ policy negotiation.  \n© 2023, 3GPP Organizational Partners (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC).  \nAll rights reserved.\n"},"externalDocs":{"description":"3GPP TS 29.522 V18.4.0; 5G System; Network Exposure Function Northbound APIs.\n","url":"https://www.3gpp.org/ftp/Specs/archive/29_series/29.522/"},"security":[{},{"oAuth2ClientCredentials":[]}],"servers":[{"url":"{apiRoot}/3gpp-pdtq-policy-negotiation/v1","variables":{"apiRoot":{"default":"https://example.com","description":"apiRoot as defined in clause 5.2.4 of 3GPP TS 29.122."}}}],"paths":{"/{afId}/subscriptions":{"parameters":[{"name":"afId","description":"String identifying the AF.","in":"path","required":true,"schema":{"type":"string"}}],"get":{"summary":"Fetches all active PDTQ policy subscription resources for a given AF.","operationId":"FetchAllActivePDTQSubscriptions","tags":["PDTQ Policy Subscriptions"],"responses":{"200":{"description":"OK, all active PDTQ policy subscriptions resources returned.","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Pdtq"},"minItems":1,"description":"Contains individual PDTQ policy subscriptions."}}}},"307":{"$ref":"TS29122_CommonData.yaml#/components/responses/307"},"308":{"$ref":"TS29122_CommonData.yaml#/components/responses/308"},"400":{"$ref":"TS29122_CommonData.yaml#/components/responses/400"},"401":{"$ref":"TS29122_CommonData.yaml#/components/responses/401"},"403":{"$ref":"TS29122_CommonData.yaml#/components/responses/403"},"404":{"$ref":"TS29122_CommonData.yaml#/components/responses/404"},"406":{"$ref":"TS29122_CommonData.yaml#/components/responses/406"},"429":{"$ref":"TS29122_CommonData.yaml#/components/responses/429"},"500":{"$ref":"TS29122_CommonData.yaml#/components/responses/500"},"503":{"$ref":"TS29122_CommonData.yaml#/components/responses/503"},"default":{"$ref":"TS29122_CommonData.yaml#/components/responses/default"}}},"post":{"summary":"Creates a new PDTQ policy subscription resource.","operationId":"CreatePDTQSubscription","tags":["PDTQ Policy Subscriptions"],"requestBody":{"description":"Contains the data to create a PDTQ Policy Subscription.","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Pdtq"}}}},"responses":{"201":{"description":"An Individual PDTQ Policy Subscription resource is created and a representation of that resource is returned.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Pdtq"}}},"headers":{"Location":{"description":"Contains the URI of the newly created resource.","required":true,"schema":{"type":"string"}}}},"400":{"$ref":"TS29122_CommonData.yaml#/components/responses/400"},"401":{"$ref":"TS29122_CommonData.yaml#/components/responses/401"},"403":{"$ref":"TS29122_CommonData.yaml#/components/responses/403"},"404":{"$ref":"TS29122_CommonData.yaml#/components/responses/404"},"411":{"$ref":"TS29122_CommonData.yaml#/components/responses/411"},"413":{"$ref":"TS29122_CommonData.yaml#/components/responses/413"},"415":{"$ref":"TS29122_CommonData.yaml#/components/responses/415"},"429":{"$ref":"TS29122_CommonData.yaml#/components/responses/429"},"500":{"$ref":"TS29122_CommonData.yaml#/components/responses/500"},"503":{"$ref":"TS29122_CommonData.yaml#/components/responses/503"},"default":{"$ref":"TS29122_CommonData.yaml#/components/responses/default"}},"callbacks":{"PDTQWarningNotification":{"{$request.body#/notificationDestination}":{"post":{"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Notification"}}}},"responses":{"204":{"description":"No Content, (successful notification)."},"307":{"$ref":"TS29122_CommonData.yaml#/components/responses/307"},"308":{"$ref":"TS29122_CommonData.yaml#/components/responses/308"},"400":{"$ref":"TS29122_CommonData.yaml#/components/responses/400"},"401":{"$ref":"TS29122_CommonData.yaml#/components/responses/401"},"403":{"$ref":"TS29122_CommonData.yaml#/components/responses/403"},"404":{"$ref":"TS29122_CommonData.yaml#/components/responses/404"},"411":{"$ref":"TS29122_CommonData.yaml#/components/responses/411"},"413":{"$ref":"TS29122_CommonData.yaml#/components/responses/413"},"415":{"$ref":"TS29122_CommonData.yaml#/components/responses/415"},"429":{"$ref":"TS29122_CommonData.yaml#/components/responses/429"},"500":{"$ref":"TS29122_CommonData.yaml#/components/responses/500"},"503":{"$ref":"TS29122_CommonData.yaml#/components/responses/503"},"default":{"$ref":"TS29122_CommonData.yaml#/components/responses/default"}}}}}}}},"/{afId}/subscriptions/{subscriptionId}":{"parameters":[{"name":"afId","description":"String identifying the AF.","in":"path","required":true,"schema":{"type":"string"}},{"name":"subscriptionId","description":"String identifying the individual PDTQ policy resource in the NEF.","in":"path","required":true,"schema":{"type":"string"}}],"get":{"summary":"Read a PDTQ subscription resource.","operationId":"FetchIndPDTQSubscription","tags":["Individual PDTQ Policy Subscription"],"responses":{"200":{"description":"OK, a representation of an Individual Policy Subscription resource is returned.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Pdtq"}}}},"307":{"$ref":"TS29122_CommonData.yaml#/components/responses/307"},"308":{"$ref":"TS29122_CommonData.yaml#/components/responses/308"},"400":{"$ref":"TS29122_CommonData.yaml#/components/responses/400"},"401":{"$ref":"TS29122_CommonData.yaml#/components/responses/401"},"403":{"$ref":"TS29122_CommonData.yaml#/components/responses/403"},"404":{"$ref":"TS29122_CommonData.yaml#/components/responses/404"},"406":{"$ref":"TS29122_CommonData.yaml#/components/responses/406"},"429":{"$ref":"TS29122_CommonData.yaml#/components/responses/429"},"500":{"$ref":"TS29122_CommonData.yaml#/components/responses/500"},"503":{"$ref":"TS29122_CommonData.yaml#/components/responses/503"},"default":{"$ref":"TS29122_CommonData.yaml#/components/responses/default"}}},"patch":{"summary":"Modifies an existing PDTQ policy subscription resource.","operationId":"ModifyIndPDTQSubscription","tags":["Individual PDTQ Policy Subscription"],"requestBody":{"description":"Contains modifications to be performed on the Pdtq data structure.","required":true,"content":{"application/merge-patch+json":{"schema":{"$ref":"#/components/schemas/PdtqPatch"}}}},"responses":{"200":{"description":"The Individual PDTQ Policy Subscription resource is modified and a representation of that resource is returned.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Pdtq"}}}},"204":{"description":"The Individual PDTQ Policy Subscription resource is modified."},"307":{"$ref":"TS29122_CommonData.yaml#/components/responses/307"},"308":{"$ref":"TS29122_CommonData.yaml#/components/responses/308"},"400":{"$ref":"TS29122_CommonData.yaml#/components/responses/400"},"401":{"$ref":"TS29122_CommonData.yaml#/components/responses/401"},"403":{"$ref":"TS29122_CommonData.yaml#/components/responses/403"},"404":{"$ref":"TS29122_CommonData.yaml#/components/responses/404"},"411":{"$ref":"TS29122_CommonData.yaml#/components/responses/411"},"413":{"$ref":"TS29122_CommonData.yaml#/components/responses/413"},"415":{"$ref":"TS29122_CommonData.yaml#/components/responses/415"},"429":{"$ref":"TS29122_CommonData.yaml#/components/responses/429"},"500":{"$ref":"TS29122_CommonData.yaml#/components/responses/500"},"503":{"$ref":"TS29122_CommonData.yaml#/components/responses/503"},"default":{"$ref":"TS29122_CommonData.yaml#/components/responses/default"}}},"delete":{"summary":"Delete a PDTQ policy subscription resource.","operationId":"DeleteIndPDTQSubscription","tags":["Individual PDTQ Policy Subscription"],"responses":{"204":{"description":"The Individual PDTQ Policy Subscription resource is deleted."},"307":{"$ref":"TS29122_CommonData.yaml#/components/responses/307"},"308":{"$ref":"TS29122_CommonData.yaml#/components/responses/308"},"400":{"$ref":"TS29122_CommonData.yaml#/components/responses/400"},"401":{"$ref":"TS29122_CommonData.yaml#/components/responses/401"},"403":{"$ref":"TS29122_CommonData.yaml#/components/responses/403"},"404":{"$ref":"TS29122_CommonData.yaml#/components/responses/404"},"429":{"$ref":"TS29122_CommonData.yaml#/components/responses/429"},"500":{"$ref":"TS29122_CommonData.yaml#/components/responses/500"},"503":{"$ref":"TS29122_CommonData.yaml#/components/responses/503"},"default":{"$ref":"TS29122_CommonData.yaml#/components/responses/default"}}}}},"components":{"securitySchemes":{"oAuth2ClientCredentials":{"type":"oauth2","flows":{"clientCredentials":{"tokenUrl":"{tokenUrl}","scopes":{}}}}},"schemas":{"Pdtq":{"description":"Represents a PDTQ Policy Subscription.","type":"object","properties":{"altQosParamSets":{"type":"array","items":{"$ref":"TS29543_Npcf_PDTQPolicyControl.yaml#/components/schemas/AltQosParamSet"},"minItems":1,"description":"Contains the alternative QoS requirements as a list of individual QoS parameter sets in a prioritized order.\n"},"altQosRefs":{"type":"array","items":{"type":"string"},"minItems":1,"description":"Contains the alternative QoS requirements as the list of QoS references in a prioritized order.\n"},"appId":{"$ref":"TS29571_CommonData.yaml#/components/schemas/ApplicationId"},"aspId":{"description":"Contains an identity of an application service provider.","type":"string"},"desTimeInts":{"type":"array","items":{"$ref":"TS29122_CommonData.yaml#/components/schemas/TimeWindow"},"minItems":1,"description":"Identifies the time interval(s)."},"locationArea5G":{"$ref":"TS29122_CommonData.yaml#/components/schemas/LocationArea5G"},"notificationDestination":{"$ref":"TS29122_CommonData.yaml#/components/schemas/Link"},"numberOfUEs":{"type":"integer","description":"Identifies the number of UEs."},"pdtqPolicies":{"type":"array","items":{"$ref":"TS29543_Npcf_PDTQPolicyControl.yaml#/components/schemas/PdtqPolicy"},"minItems":1,"description":"Contains the PDTQ policies."},"qosParamSet":{"$ref":"TS29543_Npcf_PDTQPolicyControl.yaml#/components/schemas/QosParameterSet"},"qosReference":{"type":"string","description":"Requested QoS requirements expressed as the QoS Reference which represents a pre-defined QoS information.\n"},"referenceId":{"$ref":"TS29543_Npcf_PDTQPolicyControl.yaml#/components/schemas/PdtqReferenceId"},"selectedPolicy":{"type":"integer","description":"Identity of the selected PDTQ policy. Shall not be present in initial message exchange, can be provided by NF service consumer in a subsequent message exchange.\n"},"self":{"$ref":"TS29122_CommonData.yaml#/components/schemas/Link"},"supportedFeatures":{"$ref":"TS29571_CommonData.yaml#/components/schemas/SupportedFeatures"},"warnNotifEnabled":{"type":"boolean","description":"Indicates whether the PDTQ warning notification is enabled (true) or not (false). Default value is false.\n"}},"required":["aspId","desTimeInts","numberOfUEs"],"oneOf":[{"required":["qosReference"]},{"required":["qosParamSet"]}]},"PdtqPatch":{"description":"Represents the modification of an individual PDTQ policy subscription.","type":"object","properties":{"selectedPolicy":{"type":"integer","description":"Identity of the selected PDTQ policy."},"warnNotifEnabled":{"type":"boolean","description":"Indicates whether the PDTQ warning notification is enabled (true) or not (false).\n"},"notificationDestination":{"$ref":"TS29122_CommonData.yaml#/components/schemas/Link"}}},"Notification":{"description":"Represents a PDTQ notification.","type":"object","properties":{"pdtqRefId":{"$ref":"TS29543_Npcf_PDTQPolicyControl.yaml#/components/schemas/PdtqReferenceId"},"candPolicies":{"type":"array","items":{"$ref":"TS29543_Npcf_PDTQPolicyControl.yaml#/components/schemas/PdtqPolicy"},"minItems":1,"description":"This IE indicates a list of the candidate PDTQ policies from which the AF may select a new PDTQ policy due to network performance or DN performance degradation.\n"}},"required":["pdtqRefId","candPolicies"]}}}}